KDE 4.7 PyKDE API Reference

- KDE's Python API

# KCategorizedSortFilterProxyModel Class Reference

`from PyKDE4.kdeui import *`

Inherits: QSortFilterProxyModel → QAbstractProxyModel → QAbstractItemModel → QObject

## Detailed Description

This class lets you categorize a view. It is meant to be used along with KCategorizedView class.

In general terms all you need to do is to reimplement subSortLessThan() and compareCategories() methods. In order to make categorization work, you need to also call setCategorizedModel() class to enable it, since the categorization is disabled by default.

See also:
  KCategorizedView

Author:
  Rafael Fernández López <ereslibre@kde.org>

## Enumerations
AdditionalRoles | { CategoryDisplayRole, CategorySortRole }
## Methods
| __init__ (self, QObject parent=0)
int | compareCategories (self, QModelIndex left, QModelIndex right)
bool | isCategorizedModel (self)
bool | lessThan (self, QModelIndex left, QModelIndex right)
| setCategorizedModel (self, bool categorizedModel)
| setSortCategoriesByNaturalComparison (self, bool sortCategoriesByNaturalComparison)
| sort (self, int column, Qt::SortOrder order=Qt.AscendingOrder)
bool | sortCategoriesByNaturalComparison (self)
int | sortColumn (self)
Qt::SortOrder | sortOrder (self)
bool | subSortLessThan (self, QModelIndex left, QModelIndex right)
## Static Methods
int | naturalCompare (QString a, QString b)

## Method Documentation

__init__ | ( | self, |
|  | QObject | parent=0
| ) |  |  |

int compareCategories | ( | self, |
|  | QModelIndex | left,
|  | QModelIndex | right
| ) |  |  |

This method compares the category of the left index with the category of the right index.

Internally and if not reimplemented, this method will ask for left and right models for role CategorySortRole. In order to correctly sort categories, the data() metod of the model should return a qlonglong (or numeric) value, or a QString object. QString objects will be sorted with QString.localeAwareCompare if sortCategoriesByNaturalComparison() is true.

Note:
  Please have present that: QString(QChar(QChar.ObjectReplacementCharacter)) > QString(QChar(QChar.ReplacementCharacter)) > [ all possible strings ] > QString();

This means that QString() will be sorted the first one, while QString(QChar(QChar.ObjectReplacementCharacter)) and QString(QChar(QChar.ReplacementCharacter)) will be sorted in last position.

Warning:
  Please note that data() method of the model should return always information of the same type. If you return a QString for an index, you should return always QStrings for all indexes for role CategorySortRole in order to correctly sort categories. You can't mix by returning a QString for one index, and a qlonglong for other.

Note:
  If you need a more complex layout, you will have to reimplement this method.

Returns:
  A negative value if the category of left should be placed before the category of right. 0 if left and right are on the same category, and a positive value if the category of left should be placed after the category of right.

bool isCategorizedModel | ( |  | self ) |

Returns:
  whether the model is categorized or not. Disabled by default.

bool lessThan | ( | self, |
|  | QModelIndex | left,
|  | QModelIndex | right
| ) |  |  |

Overridden from QSortFilterProxyModel. If you are subclassing KCategorizedSortFilterProxyModel, you will probably not need to reimplement this method.

It calls compareCategories() to sort by category. If the both items are in the same category (i.e. compareCategories returns 0), then subSortLessThan is called.

Returns:
  Returns true if the item left is less than the item right when sorting.

Warning:
  You usually won't need to reimplement this method when subclassing from KCategorizedSortFilterProxyModel.

setCategorizedModel | ( | self, |
|  | bool | categorizedModel
| ) |  |  |

Enables or disables the categorization feature.

Parameters:

  | categorizedModel | whether to enable or disable the categorization feature.

setSortCategoriesByNaturalComparison | ( | self, |
|  | bool | sortCategoriesByNaturalComparison
| ) |  |  |

Set if the sorting using CategorySortRole will use a natural comparison in the case that strings were returned. If enabled, QString.localeAwareCompare will be used for sorting.

Parameters:

  | sortCategoriesByNaturalComparison | whether to sort using a natural comparison or not.

sort | ( | self, |
|  | int | column,
|  | Qt::SortOrder | order=Qt.AscendingOrder
| ) |  |  |

Overridden from QSortFilterProxyModel. Sorts the source model using column for the given order.

bool sortCategoriesByNaturalComparison | ( |  | self ) |

Returns:
  whether it is being used a natural comparison for sorting. Enabled by default.

int sortColumn | ( |  | self ) |

Returns:
  the column being used for sorting.

Qt::SortOrder sortOrder | ( |  | self ) |

Returns:
  the sort order being used for sorting.

bool subSortLessThan | ( | self, |
|  | QModelIndex | left,
|  | QModelIndex | right
| ) |  |  |

This method has a similar purpose as lessThan() has on QSortFilterProxyModel. It is used for sorting items that are in the same category.

Returns:
  Returns true if the item left is less than the item right when sorting.

## Static Method Documentation

int naturalCompare | ( | QString | a,
|  | QString | b
| ) |  |  |

Does a natural comparing of the strings. A negative value is returned if a is smaller than b. A positive value is returned if a is greater than b. 0 is returned if both values are equal.

Deprecated:
  Use KStringHandler.naturalCompare() instead.

## Enumeration Documentation

AdditionalRoles

Enumerator:

  CategoryDisplayRole = 0x17CE990A |
  CategorySortRole = 0x27857E60 |